package survey;
// Verified with OpenJML-0.17.0-alpha-14, command: "./openjml --esc --progress path/to/Counter.java"
// OpenJML then shows that all method assertions were validated

public class Counter {
  public int value;

  public Counter() {
    value = 0;
  }
  
  public Counter(int initialValue) {
    value = initialValue;
  }
  
  public void incr() {
    value = value + 1;
  }
  
  public void incrByN(int n) {
    int tmp = n;
    while (tmp > 0) {
      incr();
      tmp = tmp - 1;
    }
  }
  
  public void decr() {
    value = value - 1;
  }
  
  public void decrByN(int n) {
    int tmp = 0;
    while (tmp < n) {
      decr();
      tmp = tmp + 1;
    }
  }

  public int get() {
    return value;
  }
  
  public void set(int n) {
    value = n;
  }
  
}