// Prompt: I have some Java code, can you annotate this program with JML (java modelling language) Specifications.

public class RandomSearch {
    
    public static int search(int[] array, int value) {
        if (value < array[0]) return -1;
        if (value > array[array.length-1]) return -1;
        int lo = 0;
        int hi = array.length-1;
        while (lo <= hi) {
            int mid = lo + (hi-lo)/2;
            if (array[mid] == value) {
                return mid;
            } else if (array[mid] < value) {
                lo = mid+1;
            } else {
                hi = mid-1;
            }
        }
        return -1;
    }
}
