package list;

class ListTester {
  private static ArrayList list = new ArrayList();
  private static java.util.Random rnd = new java.util.Random(1000);

  public static void size() {
    list.size();
  }
  
  public static void getExistingIndex() {
    if (list.size() > 0) {
      int index = rnd.nextInt(list.size());
      list.get(index);
    }
  }
  
  public static void getNegativeIndex() {
    try {
      int index = rnd.nextInt(list.size()+2) * -1;
      list.get(index);
    } catch (IndexOutOfBoundsException e) {
    }
  }
  
  public static void getOutOfBoundsIndex() {
    try {
      int index = rnd.nextInt(list.size()+2) + list.size();
      list.get(index);
    } catch (IndexOutOfBoundsException e) {
    
    }
  }
  
  public static void containsExistingObject() {
    if (list.size() > 0) {
      Object elem = list.get(rnd.nextInt(list.size()));
      list.contains(elem);
    }
  }
  
  public static void containsNonExistingObject() {
    Object o = new Object();
    list.contains(o);
  }
  
  public static void setNegativeIndex() {
    try {
      Object o = new Object();
      list.set(rnd.nextInt(list.size()+2)*-1, o);
    } catch (IndexOutOfBoundsException e) {
    }
  }
  
  public static void setCorrectIndex() {
    if (list.size() > 0) {
      Object o = new Object();
      list.set(rnd.nextInt(list.size()), o);
    }
  }
  
  public static void setOutOfBoundsIndex() {
    try {
      Object o = new Object();
      int index = rnd.nextInt(1000) + list.size();
      list.set(index, o);
    } catch (IndexOutOfBoundsException e) {
    }
  }
  
  public static void add() {
    list.add(new Object());
  }
  
  public static void removeExistingElement() {
    if (list.size() > 0) {
      Object o = list.get(rnd.nextInt(list.size()));
      list.remove(o);
    }
  }
  
  public static void removeNonExistingElement() {
    Object o = new Object();
    list.remove(o);
  }
  
  public static void isEmpty() {
    list.isEmpty();
  }

  public static void main(String[] args) {
    int max = rnd.nextInt(3000);
    for(int i=0; i<max; ++i) {
      switch(rnd.nextInt(12)) {
        case 0: size();
        case 1: getExistingIndex();
        case 2: getNegativeIndex();
        case 3: getOutOfBoundsIndex();
        case 4: containsExistingObject();
        case 5: containsNonExistingObject();
        case 6: setNegativeIndex();
        case 7: setCorrectIndex();
        case 8: setOutOfBoundsIndex();
        case 9: add();
        case 10: removeExistingElement();
        case 11: removeNonExistingElement();
        case 12: isEmpty();
      }
    }
  }

}