package search;
import java.util.Arrays;

class SearchTester {
  private static java.util.Random rnd = new java.util.Random(1000);

  public static int[] newArray() {
    int len = rnd.nextInt(100) + 1;
    int[] arr = new int[len];
    for (int i = 0; i < len; i++) {
      arr[i] = rnd.nextInt();
    }
    Arrays.sort(arr);
    return arr;
  }

  public static void searchForExistingElement(int[] arr) {
    int elem = rnd.nextInt(arr.length);
    BinarySearchGood.search(arr, arr[elem]);
  }
  
  public static void searchForRandomElement(int[] arr) {
    int elem = rnd.nextInt(2000);
    BinarySearchGood.search(arr, elem);
  }

  public static void main(String[] args) {
    int max = rnd.nextInt(2000);
    int[] arr = newArray();
    for(int i=0; i<max; ++i) {
      switch(rnd.nextInt(1)) {
        case 0: arr = newArray();
        case 1: searchForExistingElement(arr);
        case 2: searchForRandomElement(arr);
      }
    }
  }

}